package org.processmining.plugins.ltlchecker;

import javax.swing.JComponent;

import org.processmining.contexts.uitopia.annotations.Visualizer;
import org.processmining.framework.connections.ConnectionCannotBeObtained;
import org.processmining.framework.connections.ConnectionManager;
import org.processmining.framework.plugin.PluginContext;
import org.processmining.framework.plugin.annotations.Plugin;
import org.processmining.framework.plugin.annotations.PluginVariant;
import org.processmining.framework.plugin.events.Logger.MessageLevel;

@Plugin(name = "LTL Checker Visualization", returnLabels = { "Visualization of LTL Checker results" }, returnTypes = { JComponent.class }, parameterLabels = { "LTLVerificationResult" }, userAccessible = true)
@Visualizer
public class CheckVisualizer {
	@PluginVariant(requiredParameterLabels = { 0 })
	public JComponent visualize(PluginContext context, JComponent frame) {

		context.addConnection(new CheckVisualizerConnection(frame));
		ConnectionManager cm = context.getConnectionManager();
		try {
			Thread.sleep(1000);
		} catch (InterruptedException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
		try {
			if (cm.getConnections(CheckVisualizerConnection.class, context) != null) {
				return frame;
			}
			return null;
		} catch (ConnectionCannotBeObtained e) {
			// No connections available
			context.log("Connection does not exist", MessageLevel.DEBUG);
			return null;
		}
	}
}