/***********************************************************
 * This software is part of the ProM package * http://www.processmining.org/ * *
 * Copyright (c) 2003-2006 TU/e Eindhoven * and is licensed under the * Common
 * Public License, Version 1.0 * by Eindhoven University of Technology *
 * Department of Information Systems * http://is.tm.tue.nl * *
 **********************************************************/

package org.processmining.plugins.ltlchecker;

import java.awt.Color;

import javax.swing.JInternalFrame;

import com.fluxicon.slickerbox.components.SlickerTabbedPane;

/**
 * LTLVerificationResult is a JPanel representing two lists, one with good
 * process instances, and one with the bad ones. Between those lists, a
 * visualisation of an ProcessInstance can be made.
 * 
 * @version 0.1
 * @author Fabrizio M. Maggi
 */
@SuppressWarnings({ "serial", "unused" })
public class LTLVerificationResult extends JInternalFrame {

	//FIELDS

	public CheckResultObject getCrObj() {
		return crObj;
	}

	public void setCrObj(CheckResultObject crObj) {
		this.crObj = crObj;
	}

	private SlickerTabbedPane tpRules;
	private SlickerTabbedPane tpInstances;
	CheckResultObject crObj;

	//CONSTRUCTORS
	public LTLVerificationResult(CheckResultObject crObj) {
		this.crObj = crObj;
		createGui();
	}

	//METHODS
	private void createGui() {
		SlickerTabbedPane tpInstances = new SlickerTabbedPane("Instances inspector", new Color(240, 240, 240, 230),
				new Color(0, 0, 0, 230), new Color(220, 220, 220, 150));
		SlickerTabbedPane tpRules = new SlickerTabbedPane("Rules inspector", new Color(240, 240, 240, 230), new Color(
				0, 0, 0, 230), new Color(220, 220, 220, 150));
		int badInstances = crObj.getBadInstances();
		int goodInstances = crObj.getInstances().length - badInstances;
		int badRules = crObj.getBadRules();
		int goodRules = crObj.getRules().length - badRules;

		tpInstances.addTab("Correct process instances (" + goodInstances + ")", new CheckResultsInstanceBrowser(crObj,
				true));

		tpInstances.addTab("Incorrect process instances (" + badInstances + ")", new CheckResultsInstanceBrowser(crObj,
				false));

		tpRules.addTab("Satisfied Rules (" + goodRules + ")", new CheckResultsRuleBrowser(crObj, true));

		tpRules.addTab("Unsatisfied Rules (" + badRules + ")", new CheckResultsRuleBrowser(crObj, false));
		this.tpInstances = tpInstances;
		this.tpRules = tpRules;
	}

	public SlickerTabbedPane getTpInstances() {
		return tpInstances;
	}

	public void setTpInstances(SlickerTabbedPane tpInstances) {
		this.tpInstances = tpInstances;
	}

	public SlickerTabbedPane getTpRules() {
		return tpRules;
	}

	public void setTpRules(SlickerTabbedPane tpRules) {
		this.tpRules = tpRules;
	}
}
