/*
 * Copyright (c) 2007 Christian W. Guenther (christian@deckfour.org)
 * 
 * LICENSE:
 * 
 * This code is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later
 * version.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 51
 * Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA
 * 
 * EXEMPTION:
 * 
 * License to link and use is also granted to open source programs which are not
 * licensed under the terms of the GPL, given that they satisfy one or more of
 * the following conditions: 1) Explicit license is granted to the ProM and
 * ProMimport programs for usage, linking, and derivative work. 2) Carte blance
 * license is granted to all programs developed at Eindhoven Technical
 * University, The Netherlands, or under the umbrella of STW Technology
 * Foundation, The Netherlands. For further exemptions not covered by the above
 * conditions, please contact the author of this code.
 */
package org.processmining.plugins.ltlchecker;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Image;
import java.io.IOException;

import javax.swing.BorderFactory;
import javax.swing.ImageIcon;
import javax.swing.JComponent;
import javax.swing.JPanel;

import com.fluxicon.slickerbox.components.IconVerticalTabbedPane;
import com.fluxicon.slickerbox.components.SlickerTabbedPane;

/**
 * @author Fabrizio M. Maggi
 * 
 */
public class SlickerOpenCheckResults extends JPanel {
	/**
	 * 
	 */
	private static final long serialVersionUID = 8034419818442096689L;
	protected Image inspectorIcon;
	protected SlickerTabbedPane resRules;
	protected SlickerTabbedPane resInstances;

	
	public JComponent showLogVis(SlickerTabbedPane resRules,
			SlickerTabbedPane resInstances) {
		this.resRules = resRules;
		this.resInstances = resInstances;
		initialize();
		completeGui();
		return this;
	}

	/**
	 * loads the log and initializes this component
	 */
	protected void initialize() {
		String promDir = System.getProperty("user.dir");
		if (promDir.endsWith(".")) {
			promDir = promDir.substring(0, promDir.length() - 1);
		}
		if (promDir.endsWith(System.getProperty("file.separator")) == false) {
			promDir += System.getProperty("file.separator");
		}
		java.io.InputStream is = ClassLoader.getSystemClassLoader().getResourceAsStream("lib/images/inspector48.png");
		byte[] img = new byte[740];
		try {
			is.read(img);
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		inspectorIcon = (new ImageIcon(img)).getImage();
		setBackground(new Color(40, 40, 40));
		setBorder(BorderFactory.createEmptyBorder());
		setLayout(new BorderLayout());
	}

	protected void completeGui() {
		IconVerticalTabbedPane iconTabs = new IconVerticalTabbedPane(new Color(230, 230, 230, 210), new Color(20, 20,
				20, 160));
		iconTabs.addTab("LTL Rules", inspectorIcon, resRules);
		iconTabs.addTab("Instances", inspectorIcon, resInstances);
		add(iconTabs, BorderLayout.CENTER);
		revalidate();
		repaint();
	}
}
