package org.processmining.plugins.ltlchecker.visualizing;

import javax.swing.JComponent;

import org.processmining.contexts.uitopia.annotations.Visualizer;
import org.processmining.framework.connections.ConnectionCannotBeObtained;
import org.processmining.framework.connections.ConnectionManager;
import org.processmining.framework.plugin.PluginContext;
import org.processmining.framework.plugin.annotations.Plugin;
import org.processmining.framework.plugin.annotations.PluginVariant;
import org.processmining.framework.plugin.events.Logger.MessageLevel;
import org.processmining.plugins.ltlchecker.CheckResultObject;
import org.processmining.plugins.ltlchecker.LTLVerificationResult;
import org.processmining.plugins.ltlchecker.SlickerOpenCheckResults;

@Plugin(name = "LTL Checker Visualization", returnLabels = { "Visualization of LTL checking results" }, returnTypes = { JComponent.class }, parameterLabels = { "LTLCheckerFrame" }, userAccessible = true)
@Visualizer
public class LTLCheckerVisualization {
	@PluginVariant(requiredParameterLabels = { 0 })
	public JComponent visualize(final PluginContext context, final CheckResultObject outputFrame) {
		//DeclareModelInformationPanel frame = new DeclareModelInformationPanel(model, context.getProgress());
		LTLVerificationResult res = new LTLVerificationResult(outputFrame);
		final JComponent outputComponent = new SlickerOpenCheckResults().showLogVis(
				res.getTpRules(), res.getTpInstances());
		context.addConnection(new LTLViewerConnection(outputComponent));
		final ConnectionManager cm = context.getConnectionManager();
		try {
			if (cm.getConnections(LTLViewerConnection.class, context) != null)
				return outputComponent;
			return null;
		} catch (final ConnectionCannotBeObtained e) {
			// No connections available
			context.log("Connection does not exist", MessageLevel.DEBUG);
			return null;
		}
	}
}
